/* -*- mode: c++; c-basic-offset: 3 -*- */
#include "config.h"

#include <algorithm>   
#include <sstream>   
#include <memory>   
   
// GenericAPI Header Files   
#include "genericAPI/swigexception.hh"
#include "general/gpstime.hh"

#include "framecpp/FrAdcData.hh"
#include "framecpp/FrProcData.hh"

// Local Header Files
#include "rdsreduce.hh"
#include "filereader.hh"   
#include "rdsutil.hh"   

using namespace std;
using namespace FrameCPP::Version;   
using General::GPSTime;   

   
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
ReduceRawFrame::
ReduceRawFrame( const char* frame_files, 
		const char* channels,
		const RDSFrame::Options& UserOptions )
   : RDSFrame( frame_files, channels, UserOptions )
{
}
   
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
ReduceRawFrame::
ReduceRawFrame( const frame_file_container_type& frame_files, 
		const channel_container_type& channels,
		const RDSFrame::Options& UserOptions )
   : RDSFrame( frame_files, channels, UserOptions )
{
}
   
   
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
ReduceRawFrame::
~ReduceRawFrame()
{
}
   
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
void ReduceRawFrame::
processChannel( INT_4U /* ChannelOffset */,
		fr_adc_data_type Adc )
{
   if ( Adc.get( ) && mResultFrame.get( ) && mResultFrame->GetRawData( ) )
   {
      // Append adc to current frame
      mResultFrame->GetRawData( )->RefFirstAdc( ).append( Adc );
   }
}

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
void ReduceRawFrame::
processChannel( INT_4U /* ChannelOffset */,
		fr_proc_data_type Proc )
{
   if ( Proc.get( ) && mResultFrame.get( ) )
   {
      // Append deep copy of existing channel
      mResultFrame->RefProcData( ).append( Proc );
   }
}
